<?php

namespace Tests\Unit;

use Illuminate\Foundation\Testing\RefreshDatabase;
use Tests\TestCase;

class createAdminTest extends TestCase
{
    use RefreshDatabase;

    private $user;

    public function setUp() : void
    {
        parent::setUp(); // TODO: Change the autogenerated stub

        $this->user = factory('App\User')->create(['email' => 'admin2@example.com', 'username' => 'admin2']);
    }

    /**
     * @test
     */
    public function user_must_be_logged_in_before_create_admin()
    {
        $data = [];

        $response = $this->post(route('admin.admin_management.create'), $data);

        $response->assertRedirect(route('admin.auth.login'));
    }

    /**
     * @test
     */
    public function an_authenticated_admin_can_create_admin()
    {
        $this->actingAs($this->user);

        $data = [
            'email' => 'admin1@example.com',
            'username' => 'admin1',
            'password' => '123456',
            'password_confirmation' => '123456',
        ];

        $response = $this->post(route('admin.admin_management.create'), $data);

        $response->assertSessionHas('success');
    }

    /**
     * @test
     */
    public function can_not_create_if_admin_does_not_fills_all_fields()
    {
        $this->actingAs($this->user);

        $data = [
            'email' => 'admin1@example.com',
            'username' => 'admin1',
            'password' => '123456',
        ];

        $response = $this->post(route('admin.admin_management.create'), $data);

        $response->assertSessionHasErrorsIn('default', ['password_confirmation']);
    }

    /**
     * @test
     */
    public function can_not_create_if_the_email_already_in_use()
    {
        $this->actingAs($this->user);

        $data = [
            'email' => 'admin2@example.com',
            'username' => 'admin1',
            'password' => '123456',
            'password_confirmation' => '123456'
        ];

        $response = $this->post(route('admin.admin_management.create'), $data);

        $response->assertSessionHasErrorsIn('default', ['email']);
    }

    /**
     * @test
     */
    public function can_not_create_if_the_username_already_in_use()
    {
        $this->actingAs($this->user);

        $data = [
            'email' => 'admin3@example.com',
            'username' => 'admin2',
            'password' => '123456',
            'password_confirmation' => '123456'
        ];

        $response = $this->post(route('admin.admin_management.create'), $data);

        $response->assertSessionHasErrorsIn('default', ['username']);
    }
}
